SystemOrganization addCategory: #CryptographyRSErasure!

Error subclass: #RSErasureIllegalArgumentError
	instanceVariableNames: 'outputIndex byteIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

!RSErasureIllegalArgumentError class methodsFor: 'instance creation' stamp: 'rww 5/15/2021 10:22'!
newOnOutputIndex: oIndex byteIndex: bIndex

	^ self new
		initializeOnOutputIndex: oIndex byteIndex: bIndex;
		yourself! !

!RSErasureIllegalArgumentError methodsFor: 'accessing' stamp: 'rww 5/15/2021 10:19'!
byteIndex

	^ byteIndex! !

!RSErasureIllegalArgumentError methodsFor: 'accessing' stamp: 'rww 5/15/2021 10:19'!
byteIndex: anObject

	byteIndex := anObject.! !

!RSErasureIllegalArgumentError methodsFor: 'initialize-release' stamp: 'rww 5/15/2021 10:22'!
initializeOnOutputIndex: oIndex byteIndex: bIndex

	outputIndex := oIndex.
	byteIndex := bIndex.! !

!RSErasureIllegalArgumentError methodsFor: 'accessing' stamp: 'rww 5/15/2021 10:19'!
outputIndex

	^ outputIndex! !

!RSErasureIllegalArgumentError methodsFor: 'accessing' stamp: 'rww 5/15/2021 10:19'!
outputIndex: anObject

	outputIndex := anObject.! !

Collection subclass: #RSErasureMatrix
	instanceVariableNames: 'rowCount columnCount data galois'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

!RSErasureMatrix class methodsFor: 'instance creation' stamp: 'rww 5/11/2021 11:20'!
newIdentity: size
	"FECMatrix identity: 3"

	| matrix |
	matrix := RSErasureMatrix newWithRows: size columns: size.
	1 
		to: size
		do: [:index | matrix at: index at: index put: 1].
	^ matrix! !

!RSErasureMatrix class methodsFor: 'instance creation' stamp: 'rww 5/11/2021 11:20'!
newOnData: rowsOfColumns

	"FECMatrix data: #(#(1 2 3) #(1 2 3) #(1 2 3))"

"        rows = initData.length;
        columns = initData[0].length;
        data = new byte [rows] [];
        for (int r = 0; r < rows; r++) {
            if (initData[r].length !!= columns) {
                throw new IllegalArgumentException('Not all rows have the same number of columns');
            }
            data[r] = new byte[columns];
            for (int c = 0; c < columns; c++) {
                data[r][c] = initData[r][c];
            }
        }
"

	| columnCount matrix rowCount |
	rowCount := rowsOfColumns size.
	columnCount := (rowsOfColumns at: 1) size.
	matrix := RSErasureMatrix newWithRows: rowCount columns: columnCount.
	1
		to: rowCount
		do: [:rowIndex |
			matrix at: rowIndex put: (rowsOfColumns at: rowIndex) copy].
	^ matrix

! !

!RSErasureMatrix class methodsFor: 'instance creation' stamp: 'rww 5/11/2021 11:21'!
newWithRows: rCount columns: cCount
	"FECMatrix rows: 3 columns: 3"
	
	^ RSErasureMatrix new
		initRowCount: rCount columnCount: cCount;
		yourself.
! !

!RSErasureMatrix methodsFor: 'arithmetic' stamp: 'rww 4/21/2021 13:33'!
* right

	^ self times: right! !

!RSErasureMatrix methodsFor: 'testing' stamp: 'rww 4/21/2021 09:48'!
== other

	(other getClass ~= self getClass)
		ifTrue: [^ false].
	(other rowCount ~= self rowCount)
		ifTrue: [^ false].
	(other columnCount ~= self columnCount)
		ifTrue: [^ false].
	1
		to: self rowCount
		do: [:rowIndex |
			(self at: rowIndex = other at: rowIndex)
				ifFalse: [^ false]].
	^ true
! !

!RSErasureMatrix methodsFor: 'accessing' stamp: 'rww 4/21/2021 10:25'!
add: column

	data := data copy asOrderedCollection 
		add: column copy; 
		asArray.
	^ column! !

!RSErasureMatrix methodsFor: 'printing' stamp: 'rww 4/6/2021 11:09'!
asText
	^self asString asText! !

!RSErasureMatrix methodsFor: 'accessing' stamp: 'rww 4/21/2021 09:43'!
at: r

	(r < 0 | (rowCount < r))
		ifTrue: [Exception signal: 'Row index out of range: ',  r].
	^ data at: r! !

!RSErasureMatrix methodsFor: 'accessing' stamp: 'rww 4/21/2021 09:36'!
at: r at: c

	(r < 0 | (rowCount < r))
		ifTrue: [Exception signal: 'Row index out of range: ',  r].
	(c < 0 | (columnCount < c))
		ifTrue: [Exception signal: 'Column index out of range: ', c].
	^ (self at: r) at: c
! !

!RSErasureMatrix methodsFor: 'accessing' stamp: 'rww 4/21/2021 13:52'!
at: r at: c put: val

	| myData |
	(r < 0 | (rowCount < r))
		ifTrue: [Exception signal: 'Row index out of range: ',  r].
	(c < 0 | (columnCount < c))
		ifTrue: [Exception signal: 'Column index out of range: ', c].
	myData := self data asOrderedCollection.
	myData at: r put: ((myData at: r) asOrderedCollection
		at: c put: val;
		asArray).
	data := myData asArray.
	^ val
! !

!RSErasureMatrix methodsFor: 'accessing' stamp: 'rww 4/21/2021 10:26'!
at: r put: column

	(r < 0 | (rowCount < r))
		ifTrue: [Exception signal: 'Row index out of range: ',  r].
	data := data asOrderedCollection
		at: r put: column shallowCopy;
		asArray.
	^ data at: r
 ! !

!RSErasureMatrix methodsFor: 'private' stamp: 'rww 4/21/2021 13:07'!
augment: right

	^ self concat: right! !

!RSErasureMatrix methodsFor: 'accessing' stamp: 'rww 4/6/2021 11:16'!
columnCount

	^ columnCount! !

!RSErasureMatrix methodsFor: 'accessing' stamp: 'rww 4/6/2021 11:16'!
columnCount: anObject

	columnCount := anObject.! !

!RSErasureMatrix methodsFor: 'private' stamp: 'rww 5/11/2021 11:20'!
concat: right

"    /**
     * Returns the concatenation of this matrix and the matrix on the right.
     */"

	| result |
	(self rowCount ~= right rowCount)
		ifTrue: [Exception signal: 'Matrices don''t have thr same number of rows'].
	result := RSErasureMatrix newWithRows: self rowCount columns: (self columnCount + right columnCount).
	1
		to: self rowCount
		do: [:rowIndex |
			1
				to: self columnCount
				do: [:columnIndex |
					result at: rowIndex at: columnIndex put: (self at: rowIndex at: columnIndex)].
			1
				to: right columnCount
				do: [:columnIndex |
					result at: rowIndex at: (self columnCount + columnIndex) put: (right at: rowIndex at: columnIndex)]].
	^ result! !

!RSErasureMatrix methodsFor: 'accessing' stamp: 'rww 4/21/2021 09:02'!
data

	^ data! !

!RSErasureMatrix methodsFor: 'accessing' stamp: 'rww 4/21/2021 09:02'!
data: anObject

	data := anObject.! !

!RSErasureMatrix methodsFor: 'enumerating' stamp: 'rww 4/21/2021 13:46'!
do: aBlock

	"Pass elements to aBlock one at a time in row-major order."
	data do: aBlock! !

!RSErasureMatrix methodsFor: 'private' stamp: 'rww 5/29/2021 08:54'!
gaussianElimination
"    /**
     * Does the work of matrix inversion.
     *
     * Assumes that this is an r by 2r matrix.
     */

      // Clear out the part below the main diagonal and scale the main
      // diagonal to be 1."
	| scale |
	1
		to: self rowCount
		do: [:rowIndex |
			((self at: rowIndex at: rowIndex) = 0)
				ifTrue: [(rowIndex + 1 to: self rowCount)
					detect: [:rowBelow |
						| detected |
						detected := ((self at: rowBelow at: rowIndex) ~= 0).
						detected 
							ifTrue: [self swapRow1: rowIndex row2: rowBelow].
						detected]
					ifNone: []].
"    		      // If we couldn't find one, the matrix is singular."
			((self at: rowIndex at: rowIndex) = 0)
				ifTrue: [Exception signal: 'Matrix is singular'].
"           // Scale to 1."
		((self at: rowIndex at: rowIndex) ~= 1)
			ifTrue: [
				scale := galois divide: 1 by: (self at: rowIndex at: rowIndex).
				1
					to: self columnCount
					do: [:columnIndex |
						self at: rowIndex at: columnIndex put: (galois galoisMultiply:(self at: rowIndex at: columnIndex) by: scale)]].
"           // Make everything below the 1 be a 0 by subtracting
            // a multiple of it.  (Subtraction and addition are
            // both exclusive or in the Galois field.)"
		rowIndex + 1
			to: rowCount
			do: [:belowIndex |
				scale := self at: belowIndex at: rowIndex.
				1
					to: self columnCount
					do: [:columnIndex |
						self at: belowIndex at: columnIndex put: (galois 
							addOrSubtract: (self at: belowIndex at: columnIndex) 
							by: (galois galoisMultiply: scale by: (self at: rowIndex at: columnIndex)))]]].
"        // Now clear the part above the main diagonal."
	1
		to: self rowCount
		do: [:rowIndex |
			1
				to: rowIndex
				do: [:aboveIndex |
					(rowIndex = aboveIndex)
						ifFalse: [
							"if rowIndex equals aboveIndex bail out"
							((self at: aboveIndex at: rowIndex) ~= 0)
								ifTrue: [
									scale := self at: aboveIndex at: rowIndex.
									1
										to: self columnCount
										do: [:columnIndex |
											self at: aboveIndex at: columnIndex put: (galois
												addOrSubtract: (self at: aboveIndex at: columnIndex) 
												by: (galois galoisMultiply: scale by: (self at: rowIndex at: columnIndex)))]]]]].! !

!RSErasureMatrix methodsFor: 'initialize-release' stamp: 'rww 5/16/2021 10:58'!
initRowCount: rCount columnCount: cCount

	| columnArray |
	self
		rowCount: rCount;
		columnCount: cCount.
	data := Array new.
	columnArray := ByteArray new: cCount withAll: 0.
	1 to: rCount do: [:rowIndex | self add: columnArray copy].
	galois := RSErasureGalois newGalois.! !

!RSErasureMatrix methodsFor: 'modifying' stamp: 'rww 5/11/2021 11:20'!
invert

"    /**
     * Returns the inverse of this matrix.
     *
     * @throws IllegalArgumentException when the matrix is singular and
     * doesn't have an inverse.
     */
    public Matrix invert() {
        // Sanity check.
        if (rows !!= columns) {
            throw new IllegalArgumentException('Only square matrices can be inverted');
        }

        // Create a working matrix by augmenting this one with
        // an identity matrix on the right.
        Matrix work = augment(identity(rows));

        // Do Gaussian elimination to transform the left half into
        // an identity matrix.
        work.gaussianElimination();

        // The right half is now the inverse.
        return work.submatrix(0, rows, columns, columns * 2);
    }
"

	| result |
	(self rowCount ~= self columnCount)
		ifTrue: [Exception signal: 'Only square matrices can be inverted'].
	result := self augment: (RSErasureMatrix newIdentity: self rowCount).
	result gaussianElimination.
	^ result submatrixRowMin: 1 columnMin: (self columnCount + 1) rowMax: self rowCount columnMax: (self columnCount * 2).! !

!RSErasureMatrix methodsFor: 'printing' stamp: 'rww 4/21/2021 09:41'!
printOn: aStream

	aStream nextPut: $[.
	1 
		to: self rowCount
		do: [:row |
			aStream
				nextPut: $[;
				space.
			1 
				to: self columnCount
				do: [:column |
					aStream 
						print: (self at: row at: column);
						space].
			aStream nextPut: $].
			(row >= self rowCount)
				ifFalse: [aStream cr]].
	aStream nextPut: $].
! !

!RSErasureMatrix methodsFor: 'accessing' stamp: 'rww 4/6/2021 11:16'!
rowCount

	^ rowCount! !

!RSErasureMatrix methodsFor: 'accessing' stamp: 'rww 4/6/2021 11:16'!
rowCount: anObject

	rowCount := anObject.! !

!RSErasureMatrix methodsFor: 'private' stamp: 'rww 4/21/2021 12:59'!
rows

	^ data! !

!RSErasureMatrix methodsFor: 'accessing' stamp: 'rww 5/11/2021 11:20'!
submatrixRowMin: rmin columnMin: cmin rowMax: rmax columnMax: cmax

"    /**
     * Returns a part of this matrix.
     */
    public Matrix submatrix(int rmin, int cmin, int rmax, int cmax) {
        Matrix result = new Matrix(rmax - rmin, cmax - cmin);
        for (int r = rmin; r < rmax; r++) {
            for (int c = cmin; c < cmax; c++) {
                result.data[r - rmin][c - cmin] = data[r][c];
            }
        }
        return result;
    }
"

	| result |
	((rmax > rmin) | (cmax > cmin))
		ifFalse: [Exception signal: 'max below min'].
	result := RSErasureMatrix newWithRows: (rmax - rmin + 1) columns: (cmax - cmin + 1).
	rmin
		to: rmax
		do: [:rowIndex |
			cmin
				to: cmax
				do: [:columnIndex |
					result at: (rowIndex - rmin + 1) at: (columnIndex - cmin + 1) put: (self at: rowIndex at: columnIndex)]].
	^ result! !

!RSErasureMatrix methodsFor: 'private' stamp: 'rww 4/21/2021 17:13'!
swapRow1: row1 row2: row2

"    /**
     * Exchanges two rows in the matrix.
     */"

	| tmp |
	(row1 < 0 | (row1 > rowCount))
		ifTrue: [Exception signal: 'Row index out of range: ',  row1].
	(row2 < 0 | (row2 > rowCount))
		ifTrue: [Exception signal: 'Row index out of range: ', row2].
	tmp := data at: row1.
	data at: row1 put: (data at: row2).
	data at: row2 put: tmp.! !

!RSErasureMatrix methodsFor: 'modifying' stamp: 'rww 5/16/2021 10:59'!
times: right

"    /**
     * Multiplies this matrix (the one on the left) by another
     * matrix (the one on the right).
     */
    public Matrix times(Matrix right) {
        if (getColumns() !!= right.getRows()) {
            throw new IllegalArgumentException(
                    'Columns on left (' + getColumns() +') ' +
                    'is different than rows on right (' + right.getRows() + ')');
        }
        Matrix result = new Matrix(getRows(), right.getColumns());
        for (int r = 0; r < getRows(); r++) {
            for (int c = 0; c < right.getColumns(); c++) {
                byte value = 0;
                for (int i = 0; i < getColumns(); i++) {
                    value ^= Galois.multiply(get(r, i), right.get(i, c));
                }
                result.set(r, c, value);
            }
        }
        return result;
    }
"

	| result value |
	(self columnCount ~= right rowCount)
		ifTrue: [Exception signal: ('Columns on left (', self columnCount, ') is different than rows on right (', right rowCount, ')')].
	result := RSErasureMatrix newWithRows: self rowCount columns: right columnCount.
	1
		to: self rowCount
		do: [:rowIndex |
			1
				to: right columnCount
				do: [:columnIndex |
					value := 0.
					1
						to: self columnCount
						do: [:leftIndex |
							value := value bitXor: (galois galoisMultiply: (self at: rowIndex at: leftIndex) by: (right at: leftIndex at: columnIndex))].
					result at: rowIndex at: columnIndex put: value]].
	^ result! !

Object subclass: #RSErasure
	instanceVariableNames: 'dataShardCount parityShardCount totalShardCount matrix codingLoop parityRows galois'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

!RSErasure commentStamp: 'rww 4/22/2021 09:41' prior: 0!
// Reed-Solomon Coding over 8-bit values.

Instance Variables
	codingLoop:		<Object>
	dataShardCount:		<Object>
	matrix:		<Object>
	parityRows:		<Object>
	parityShardCount:		<Object>
	totalShardCount:		<Object>

codingLoop
	- xxxxx

dataShardCount
	- xxxxx

matrix
	- xxxxx

parityRows
	- // Rows from the matrix for encoding parity, each one as its own byte array to allow for efficient access while encoding.

parityShardCount
	- xxxxx

totalShardCount
	- xxxxx
!

!RSErasure class methodsFor: 'instance creation' stamp: 'rww 5/14/2021 19:48'!
newDataShardCount: dataShardCount parityShardCount: parityShardCount
	"ReedSolomon newDataShardCount: 9 parityShardCount: 6"
	
"    /**
     * Creates a ReedSolomon codec with the default coding loop.
     */"

	^ self
		newDataShardCount: dataShardCount 
		parityShardCount: parityShardCount 
		codingLoop: RSErasureByteInputOutputExpCodingLoop new
		"codingLoop: RSErasureByteInputOutputTableCodingLoop new"
		"codingLoop: RSErasureByteOutputInputExpCodingLoop new"
		"codingLoop: RSErasureByteOutputInputTableCodingLoop new"
		"codingLoop: RSErasureInputOutputByteExpCodingLoop new"
		"codingLoop: RSErasureInputOutputByteTableCodingLoop new"
		"codingLoop: RSErasureInputByteOutputExpCodingLoop new"
		"codingLoop: RSErasureInputByteOutputTableCodingLoop new"
		"codingLoop: RSErasureOutputByteInputExpCodingLoop new"
		"codingLoop: RSErasureOutputByteInputTableCodingLoop new"
		"codingLoop: RSErasureOutputInputByteTableCodingLoop new"
		"codingLoop: RSErasureOutputInputByteExpCodingLoop new"
		"FAILED"
! !

!RSErasure class methodsFor: 'instance creation' stamp: 'rww 5/16/2021 10:56'!
newDataShardCount: dataShardCount parityShardCount: parityShardCount codingLoop: codingLoop
"    /**
     * Initializes a new encoder/decoder, with a chosen coding loop.
     */"

"        // We can have at most 256 shards total, as any more would
        // lead to duplicate rows in the Vandermonde matrix, which
        // would then lead to duplicate rows in the built matrix
        // below. Then any subset of the rows containing the duplicate
        // rows would be singular."
	(256 < (dataShardCount + parityShardCount))
		ifTrue: [Exception signal: 'too many shards - max is 256'].

	^ self new
		initializeDataShardCount: dataShardCount 
		parityShardCount: parityShardCount 
		codingLoop: codingLoop
		galois: RSErasureGalois newGalois.! !

!RSErasure methodsFor: 'private' stamp: 'rww 5/16/2021 11:22'!
buildMatrixDataShardCount: dataCount totalShardCount: totalCount

	| top vandermonde |
	vandermonde := self vandermondeTotalRowCount: totalCount columnCount: dataCount.

	top := vandermonde submatrixRowMin: 1 columnMin: 1 rowMax: dataCount columnMax: dataCount.
	^ vandermonde times: top invert.
! !

!RSErasure methodsFor: 'private' stamp: 'rww 5/16/2021 09:32'!
checkBuffers: shards offset: offset count: byteCount

	| shardLength |
	(shards size ~= totalShardCount)
		ifTrue: [RSErasureIllegalArgumentError signal: 'wrong number of shards: ', totalShardCount].

	shardLength := (shards at: 1) size.

	shards do: [:shardi |
			(shardi size ~= shardLength)
				ifTrue: [RSErasureIllegalArgumentError signal: 'shards are different sizes']].

	(offset < 0)
		ifTrue: [RSErasureIllegalArgumentError signal: 'offset is negative: ' + offset].
	(byteCount < 0)
		ifTrue: [RSErasureIllegalArgumentError signal: 'byteCount is negative: ' + byteCount].
	(shardLength < (offset + byteCount))
		ifTrue: [RSErasureIllegalArgumentError signal: 'buffers to small: ' + byteCount + offset].
! !

!RSErasure methodsFor: 'accessing' stamp: 'rww 5/13/2021 10:38'!
codingLoop

	^ codingLoop! !

!RSErasure methodsFor: 'accessing' stamp: 'rww 5/13/2021 10:38'!
codingLoop: anObject

	codingLoop := anObject.! !

!RSErasure methodsFor: 'accessing' stamp: 'rww 5/13/2021 10:38'!
dataShardCount

	^ dataShardCount! !

!RSErasure methodsFor: 'accessing' stamp: 'rww 5/13/2021 10:38'!
dataShardCount: anObject

	dataShardCount := anObject.! !

!RSErasure methodsFor: 'testing' stamp: 'rww 5/26/2021 15:03'!
debugShards: shards tempBuffer: tempBuffer firstByte: firstByte count: byteCount exception: exception

	| toCheck |
	self checkBuffers: shards offset: firstByte count: byteCount.
	(tempBuffer size < (firstByte + byteCount))
		ifTrue: [RSErasureIllegalArgumentError signal: 'tempBuffer is not big enough'].

	toCheck := Array new: parityShardCount withAll: 0.
	(dataShardCount + 1 to: totalShardCount)
		collect: [:eachParityShard |
			toCheck at: (eachParityShard - dataShardCount) put: (shards at: eachParityShard)].

	^ codingLoop
		debugValueGalois: galois
		matrixRows: parityRows
		inputs: shards
		inputCount: dataShardCount
		toCheck: toCheck
		exception: exception.
! !

!RSErasure methodsFor: 'action' stamp: 'rww 5/16/2021 09:33'!
decodeMissing: shards shardPresent: shardPresent offset: offset byteCount: byteCount

	| numberPresent subMatrix matrixRow subMatrixRow subShards dataDecodeMatrix matrixRows outputCount outputs |
	self checkBuffers: shards offset: offset count: byteCount.

	numberPresent := 0.
	1
		to: totalShardCount
		do: [:i |
			(shardPresent at: i)
				ifTrue: [numberPresent := numberPresent + 1]].

	(numberPresent = totalShardCount)
		ifTrue: [^ self].

	(numberPresent < dataShardCount)
		ifTrue: [RSErasureIllegalArgumentError signal: 'Not enough shards present'].

	subMatrix := RSErasureMatrix newWithRows: dataShardCount columns: dataShardCount.
	subShards := Array new: dataShardCount.
	[
		subMatrixRow := 1.
		matrixRow := 1.
		[(matrixRow < totalShardCount) bitAnd: (subMatrixRow < dataShardCount)]
			whileTrue: [(shardPresent at: matrixRow)
				ifTrue: [1
					to: dataShardCount
					do: [:columnIndex |
						subMatrix at: subMatrixRow at: columnIndex put: (matrix at: matrixRow at: columnIndex)].
				subShards at: subMatrixRow put: (shards at: matrixRow).
				subMatrixRow := subMatrixRow + 1]]] value.

	dataDecodeMatrix := subMatrix invert.

	outputs := Array new: parityShardCount.
	matrixRows := Array new: parityShardCount.
	outputCount := 1.
	1
		to: dataShardCount
		do: [:iShard |
			(shardPresent at: iShard)
				ifFalse: [
					outputs at: outputCount put: (shards at: iShard) copy.
					matrixRows at: outputCount put: (dataDecodeMatrix at: iShard) copy.
					outputCount := outputCount + 1]].

	 codingLoop 
		codeSomeShardsGalois: galois
		matrixRows: matrixRows 
		inputs: subShards
		inputCount: dataShardCount 
		outputs: outputs 
		outputCount: outputCount 
		offset: offset 
		byteCount: byteCount. 

	outputCount := 1.
	dataShardCount
		to: totalShardCount
		do: [:iShard |
			(shardPresent at: iShard)
				ifFalse: [
					outputs at: outputCount put: (shards at: iShard).
					matrixRows at: outputCount put: (parityRows at: (iShard - dataShardCount)).
					outputCount := outputCount + 1]].
	 codingLoop 
		codeSomeShardsGalois: galois
		matrixRows: matrixRows 
		inputs: shards
		inputCount: dataShardCount 
		outputs: outputs 
		outputCount: outputCount 
		offset: offset 
		byteCount: byteCount. 
! !

!RSErasure methodsFor: 'action' stamp: 'rww 5/16/2021 09:34'!
encodeParity: shards offset: offset byteCount: byteCount

	| outputs |
	self checkBuffers: shards offset: offset count: byteCount.

	outputs := ((dataShardCount + 1) to: totalShardCount)
		collect: [:eachParityShard | shards at: eachParityShard].

        codingLoop 
		codeSomeShardsGalois: galois
		matrixRows: parityRows 
		inputs: shards
		inputCount: dataShardCount 
		outputs: outputs 
		outputCount: parityShardCount 
		offset: offset 
		byteCount: byteCount.

! !

!RSErasure methodsFor: 'initialize-release' stamp: 'rww 5/14/2021 19:29'!
initializeDataShardCount: dataCount parityShardCount: parityCount codingLoop: loop galois: myGalois

	(256 < (dataCount + parityCount))
		ifTrue: [Exception signal: 'too many shards - max is 256'].
	dataShardCount := dataCount.
	parityShardCount := parityCount.
	codingLoop := loop.
	totalShardCount := dataCount + parityCount.
	galois := myGalois.


	"matrix = buildMatrix(dataShardCount, this.totalShardCount);
	parityRows = new byte [parityShardCount] [];
	for (int i = 0; i < parityShardCount; i++) {
		parityRows[i] = matrix.getRow(dataShardCount + i);
	}"
	matrix := self buildMatrixDataShardCount: dataShardCount totalShardCount: totalShardCount.
	parityRows := Array new: parityShardCount withAll: 0.
	1
		to: parityShardCount
		do: [:parityIndex |
			parityRows
				at: parityIndex 
				put: (matrix at: dataShardCount + parityIndex); 
				asArray].
! !

!RSErasure methodsFor: 'testing' stamp: 'rww 5/26/2021 15:04'!
isParityCorrect: shards firstByte: firstByte count: byteCount

	| toCheck |
	self checkBuffers: shards offset: firstByte count: byteCount.

	toCheck := Array new: parityShardCount withAll: 0.
	(dataShardCount + 1 to: totalShardCount)
		collect:  [:eachParityShard | toCheck at: (eachParityShard - dataShardCount) put: (shards at: eachParityShard)].

	^ codingLoop
		checkSomeShardsGalois: galois
		matrixRows: parityRows 
		inputs: shards
		inputCount: dataShardCount
		toCheck: toCheck 
		checkCount: parityShardCount 
		offset: firstByte
		byteCount: byteCount 
		tempBuffer: nil! !

!RSErasure methodsFor: 'testing' stamp: 'rww 5/26/2021 15:04'!
isParityCorrect: shards firstByte: firstByte count: byteCount buffer: tempBuffer

	| toCheck |
	self checkBuffers: shards offset: firstByte count: byteCount.
	(tempBuffer size < (firstByte + byteCount))
		ifTrue: [RSErasureIllegalArgumentError signal: 'tempBuffer is not big enough'].

	toCheck := Array new: parityShardCount withAll: 0.
	(dataShardCount + 1 to: totalShardCount)
		collect: [:eachParityShard |
			toCheck at: (eachParityShard - dataShardCount) put: (shards at: eachParityShard)].

	^ codingLoop
		checkSomeShardsGalois: galois
		matrixRows: parityRows 
		inputs: shards
		inputCount: dataShardCount
		toCheck: toCheck 
		checkCount: parityShardCount 
		offset: firstByte
		byteCount: byteCount 
		tempBuffer: tempBuffer.! !

!RSErasure methodsFor: 'accessing' stamp: 'rww 5/13/2021 10:38'!
matrix

	^ matrix! !

!RSErasure methodsFor: 'accessing' stamp: 'rww 5/13/2021 10:38'!
matrix: anObject

	matrix := anObject.! !

!RSErasure methodsFor: 'accessing' stamp: 'rww 5/13/2021 10:38'!
parityRows

	^ parityRows! !

!RSErasure methodsFor: 'accessing' stamp: 'rww 5/13/2021 10:38'!
parityRows: anObject

	parityRows := anObject.! !

!RSErasure methodsFor: 'accessing' stamp: 'rww 5/13/2021 10:38'!
parityShardCount

	^ parityShardCount! !

!RSErasure methodsFor: 'accessing' stamp: 'rww 5/13/2021 10:38'!
parityShardCount: anObject

	parityShardCount := anObject.! !

!RSErasure methodsFor: 'accessing' stamp: 'rww 5/13/2021 10:38'!
totalShardCount

	^ totalShardCount! !

!RSErasure methodsFor: 'accessing' stamp: 'rww 5/13/2021 10:38'!
totalShardCount: anObject

	totalShardCount := anObject.! !

!RSErasure methodsFor: 'private' stamp: 'rww 5/16/2021 11:24'!
vandermondeTotalRowCount: rowCount columnCount: columnCount

	| result | 
	result := RSErasureMatrix newWithRows: rowCount columns: columnCount.
	0
		to: (rowCount - 1)
		do: [:rowIndex |
			0
				to: (columnCount - 1)
				do: [:columnIndex | 
					result 
						at: (rowIndex + 1) 
						at: (columnIndex + 1) 
						put: (galois 
							exp: rowIndex
							power: columnIndex)]].
	^ result
! !

Object subclass: #RSErasureBenchmark
	instanceVariableNames: 'dataShardCount parityShardCount totalShardCount bufferSize processorCacheSize twiceProcessorCacheSize numberOfBufferSets measurementDuration nextBuffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

!RSErasureBenchmark methodsFor: 'private' stamp: 'rww 5/14/2021 17:36'!
codingLoopNameToCsvPrefix: name

	"List<String> names = splitCamelCase(className);
        return
                names.get(0) + ',' +
                names.get(1) + ',' +
                names.get(2) + ',' +
                names.get(3) + ',';"
	| names |
	names := self  splitCamelCase: name.
	^ (names at: 1), ',',
	(names at: 2), ',',
	(names at: 3), ',',
	(names at: 4), ','.! !

!RSErasureBenchmark methodsFor: 'action' stamp: 'rww 5/16/2021 15:53'!
debugCodec: codec bufferSets: bufferSets tempBuffer: tempBuffer exception:  ex

	| bufferSet bytesChecked checkingTime endTime megabytes passesCompleted result seconds shards startTime value |
	passesCompleted := 0.
	bytesChecked := 0.
	checkingTime := 0.
	Transcript cr; show: 'debugging exception for bad check'; cr.

	bufferSet := bufferSets at: nextBuffer.
	nextBuffer := ((nextBuffer + 1) \\ bufferSets size) + 1.
	shards := bufferSet buffers.
	startTime := Time millisecondClockValue.
	value := codec
		debugShards: shards
		tempBuffer: tempBuffer
		firstByte: 0
		count: bufferSize
		exception: ex.
	endTime := Time millisecondClockValue.
	checkingTime := checkingTime + (endTime - startTime).
	bytesChecked := bytesChecked + (bufferSize * dataShardCount).
	passesCompleted := passesCompleted + 1.

	seconds := checkingTime // 1000.
	megabytes := bytesChecked // 1000000.
	result := RSErasureBenchmarkMeasurement newWithMegabytes: megabytes seconds: seconds.
	Transcript show: ('        ', bufferSize, ' bufferSize, ', megabytes, ' MBs, ', seconds, ' Seconds, ', passesCompleted, ' passes, ', '  ', result); cr.
	^ result
! !

!RSErasureBenchmark methodsFor: 'private' stamp: 'rww 5/26/2021 15:04'!
doOneCheckMeasuremnt: codec bufferSets: bufferSets tempBuffer: tempBuffer

	| bufferSet bytesChecked checkingTime endTime megabytes passesCompleted result seconds shards startTime localTempBuffer |
	passesCompleted := 0.
	bytesChecked := 0.
	checkingTime := 0.
	[checkingTime < measurementDuration]
		whileTrue: [
			bufferSet := bufferSets at: nextBuffer.
			nextBuffer := ((nextBuffer + 1) \\ bufferSets size) + 1.
			shards := bufferSet buffers.
			startTime := Time millisecondClockValue.
			[codec isParityCorrect: shards firstByte: 0 count: bufferSize buffer: (localTempBuffer := Array new: bufferSize withAll: 0)]
				on: RSErasureIllegalArgumentError
				do: [:ex | self  debugCodec: codec bufferSets: bufferSets tempBuffer: (localTempBuffer := Array new: bufferSize withAll: 0) exception:  ex].
			endTime := Time millisecondClockValue.
			checkingTime := checkingTime + (endTime - startTime).
			bytesChecked := bytesChecked + (bufferSize * dataShardCount).
			passesCompleted := passesCompleted + 1].
	seconds := checkingTime // 1000.
	megabytes := bytesChecked // 1000000.
	result := RSErasureBenchmarkMeasurement newWithMegabytes: megabytes seconds: seconds.
	Transcript show: ('        ', bufferSize, ' bufferSize, ', megabytes, ' MBs, ', seconds, ' Seconds, ', passesCompleted, ' passes, ', '  ', result); cr.
	^ result
! !

!RSErasureBenchmark methodsFor: 'private' stamp: 'rww 5/14/2021 18:52'!
doOneEncodeMeasuremnt: codec bufferSets: bufferSets

	| bufferSet bytesEncoded encodingTime endTime megabytes passesCompleted result seconds shards startTime |
	passesCompleted := 0.
	bytesEncoded := 0.
	encodingTime := 0.
	[encodingTime < measurementDuration]
		whileTrue: [
			bufferSet := bufferSets at: nextBuffer.
			nextBuffer := ((nextBuffer + 1) \\ bufferSets size) + 1.
			shards := bufferSet buffers.
			startTime := Time millisecondClockValue.
			codec encodeParity: shards offset: 0 byteCount: bufferSize.
			endTime := Time millisecondClockValue.
			encodingTime := encodingTime + (endTime - startTime).
			bytesEncoded := bytesEncoded + (bufferSize * dataShardCount).
			passesCompleted := passesCompleted + 1].
	seconds := encodingTime // 1000.
	megabytes := bytesEncoded // 1000000.
	result := RSErasureBenchmarkMeasurement newWithMegabytes: megabytes seconds: seconds.
	Transcript show: ('        ', bufferSize, ' bufferSize, ', megabytes, ' MBs, ', seconds, ' Seconds, ', passesCompleted, ' passes, ', '  ', result); cr.
	^ result
! !

!RSErasureBenchmark methodsFor: 'initialize-release' stamp: 'rww 5/15/2021 09:59'!
initialize

	dataShardCount := 17.
	parityShardCount := 3.
	totalShardCount := dataShardCount + parityShardCount.
	bufferSize := 200 * 1000.
	processorCacheSize := 10 * 1024 * 1024.
	twiceProcessorCacheSize := 2 * processorCacheSize.
	numberOfBufferSets := (twiceProcessorCacheSize / dataShardCount / bufferSize) rounded + 1.
	measurementDuration := 2 * 1000.
	nextBuffer := 1.
! !

!RSErasureBenchmark methodsFor: 'action' stamp: 'rww 5/26/2021 15:04'!
run

	| bufferSets csv summaryLines encodeAverage testName codec checkAverage tempBuffer |
	Transcript clear; cr; show: 'preparing...'.
	"final BufferSet [] bufferSets = new BufferSet [NUMBER_OF_BUFFER_SETS];
        for (int iBufferSet = 0; iBufferSet < NUMBER_OF_BUFFER_SETS; iBufferSet++) {
            bufferSets[iBufferSet] = new BufferSet();
        }
        final byte [] tempBuffer = new byte [BUFFER_SIZE];"
	bufferSets := Array new: numberOfBufferSets withAll: 0.
	(1 to: numberOfBufferSets)
		collect: [:index | bufferSets at: index put: (RSErasureBenchmarkBufferSet newWithTotalCount: totalShardCount bufferSize: bufferSize)].
	tempBuffer := OrderedCollection new: bufferSize withAll: 0.
	summaryLines := OrderedCollection new.
	csv := ReadWriteStream with: ''.
	csv := csv nextPutAll: 'Outer,Middle,Inner,Multiply,Encode,Check'; cr.
	RSErasureCodingLoop allCodingLoops
		collect: [:codingLoop |
			encodeAverage := RSErasureBenchmarkMeasurement new.
			testName := codingLoop class name, ' encodeParity'.
			Transcript cr; show: ('TEST: ', testName); cr.
			codec := RSErasure newDataShardCount: dataShardCount parityShardCount: parityShardCount codingLoop: codingLoop.
			Transcript show: '    warm up...'; cr.
			self doOneEncodeMeasuremnt: codec bufferSets: bufferSets.
			self doOneEncodeMeasuremnt: codec bufferSets: bufferSets.
			Transcript show: '    testing...'; cr.
			(1 to: 10)
				collect: [:measurementIndex |
					encodeAverage add: (self doOneEncodeMeasuremnt: codec bufferSets: bufferSets)].
			Transcript cr; show: 'AVERAGE: ', encodeAverage; cr.
			summaryLines add: testName, ' ', encodeAverage.

			checkAverage := RSErasureBenchmarkMeasurement new.
			testName := codingLoop class name, ' isParityCorrect'.
			Transcript cr; show: ('TEST: ', testName); cr.
			codec := RSErasure newDataShardCount: dataShardCount parityShardCount: parityShardCount codingLoop: codingLoop.
			Transcript show: '    warm up...'; cr.
			self doOneEncodeMeasuremnt: codec bufferSets: bufferSets.
			self doOneEncodeMeasuremnt: codec bufferSets: bufferSets.
			Transcript show: '    testing...'; cr.
			(1 to: 10)
				collect: [:measurementIndex |
					checkAverage add: (self doOneCheckMeasuremnt: codec bufferSets: bufferSets tempBuffer: tempBuffer)].
			Transcript cr; show: 'AVERAGE: ', checkAverage; cr.
			summaryLines add: testName, ' ', checkAverage.

			csv nextPutAll: (self codingLoopNameToCsvPrefix: codingLoop class name).
			csv nextPutAll: encodeAverage rate asString, ', '.
			csv nextPutAll: checkAverage rate asString.
			csv cr].

	Transcript cr; show: (csv contents).
	Transcript cr; show: 'Summary:'; cr.
	summaryLines do: [:line | Transcript show: line; cr].
! !

!RSErasureBenchmark methodsFor: 'private' stamp: 'rww 5/26/2021 14:43'!
splitCamelCase: name

	| result buffer stream |
	result := OrderedCollection new.
	buffer := ''.
	stream := ReadStream on: name.
	[stream atEnd]
		 whileFalse: [stream peek isUppercase
			ifTrue: [result add: buffer.
				buffer := '', stream next]
			ifFalse: [buffer := buffer, stream next]].
	result add: buffer.
	^ result asArray! !

Object subclass: #RSErasureBenchmarkBufferSet
	instanceVariableNames: 'buffers bigBuffer totalCount bufferSize random'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

!RSErasureBenchmarkBufferSet class methodsFor: 'instance creation' stamp: 'rww 5/14/2021 13:47'!
newWithTotalCount: count bufferSize: size

	^ self new
		initializeWithTotalCount: count bufferSize: size;
		yourself! !

!RSErasureBenchmarkBufferSet methodsFor: 'accessing' stamp: 'rww 5/14/2021 13:44'!
bigBuffer

	^ bigBuffer! !

!RSErasureBenchmarkBufferSet methodsFor: 'accessing' stamp: 'rww 5/14/2021 13:44'!
bigBuffer: anObject

	bigBuffer := anObject.! !

!RSErasureBenchmarkBufferSet methodsFor: 'accessing' stamp: 'rww 5/14/2021 13:47'!
bufferSize

	^ bufferSize! !

!RSErasureBenchmarkBufferSet methodsFor: 'accessing' stamp: 'rww 5/14/2021 13:47'!
bufferSize: anObject

	bufferSize := anObject.! !

!RSErasureBenchmarkBufferSet methodsFor: 'accessing' stamp: 'rww 5/14/2021 13:44'!
buffers

	^ buffers! !

!RSErasureBenchmarkBufferSet methodsFor: 'accessing' stamp: 'rww 5/14/2021 13:44'!
buffers: anObject

	buffers := anObject.! !

!RSErasureBenchmarkBufferSet methodsFor: 'initialize-release' stamp: 'rww 5/26/2021 15:05'!
initializeWithTotalCount: count bufferSize: size

	totalCount := count.
	bufferSize := size.
	random := Random new.
	buffers := Array new: totalCount withAll: 0.
	(1 to: totalCount)
		collect: [:index | | localBuffer |
			localBuffer := Array new: bufferSize withAll: 0.
			(1 to: bufferSize)
				collect: [:slotIndex |
					localBuffer at: slotIndex put: (random nextInt: 256)].
			buffers at: index put: localBuffer].
	bigBuffer := OrderedCollection new: (totalCount * bufferSize) withAll: 0.
	(1 to: (totalCount * bufferSize))
		collect: [:index |
			bigBuffer at: index put: (random nextInt: 256)].
! !

!RSErasureBenchmarkBufferSet methodsFor: 'accessing' stamp: 'rww 5/14/2021 13:47'!
random

	^ random! !

!RSErasureBenchmarkBufferSet methodsFor: 'accessing' stamp: 'rww 5/14/2021 13:47'!
random: anObject

	random := anObject.! !

!RSErasureBenchmarkBufferSet methodsFor: 'accessing' stamp: 'rww 5/14/2021 13:47'!
totalCount

	^ totalCount! !

!RSErasureBenchmarkBufferSet methodsFor: 'accessing' stamp: 'rww 5/14/2021 13:47'!
totalCount: anObject

	totalCount := anObject.! !

Object subclass: #RSErasureBenchmarkMeasurement
	instanceVariableNames: 'megabytes seconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

!RSErasureBenchmarkMeasurement class methodsFor: 'instance creation' stamp: 'rww 5/14/2021 13:30'!
new

	^ self newWithMegabytes: 0.0 seconds: 0.0
! !

!RSErasureBenchmarkMeasurement class methodsFor: 'instance creation' stamp: 'rww 5/14/2021 13:54'!
newWithMegabytes: megabytes seconds: seconds

	^ super new
		initialieWithMegabytes: megabytes seconds: seconds;
		yourself! !

!RSErasureBenchmarkMeasurement methodsFor: 'apply primitives' stamp: 'rww 5/14/2021 13:53'!
add: measurement

	megabytes := megabytes + measurement megabytes.
	seconds := seconds + measurement seconds.! !

!RSErasureBenchmarkMeasurement methodsFor: 'initialize-release' stamp: 'rww 5/14/2021 14:03'!
initialieWithMegabytes: megas seconds: secs

	megabytes := megas.
	seconds := secs.! !

!RSErasureBenchmarkMeasurement methodsFor: 'accessing' stamp: 'rww 5/14/2021 13:52'!
megabytes

	^ megabytes! !

!RSErasureBenchmarkMeasurement methodsFor: 'accessing' stamp: 'rww 5/14/2021 13:52'!
megabytes: anObject

	megabytes := anObject.! !

!RSErasureBenchmarkMeasurement methodsFor: 'printing' stamp: 'rww 5/14/2021 18:14'!
printOn: stream

	stream nextPutAll: (self rate asString, ' MB/s').
! !

!RSErasureBenchmarkMeasurement methodsFor: 'accessing' stamp: 'rww 5/15/2021 17:19'!
rate

	((seconds == 0) | (seconds == 0.0))
		ifTrue: [^ 'N/A'].
	^ (megabytes / seconds) asFloat ! !

!RSErasureBenchmarkMeasurement methodsFor: 'accessing' stamp: 'rww 5/14/2021 13:49'!
seconds

	^ seconds! !

!RSErasureBenchmarkMeasurement methodsFor: 'accessing' stamp: 'rww 5/14/2021 13:49'!
seconds: anObject

	seconds := anObject.! !

Object subclass: #RSErasureCodingLoop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

!RSErasureCodingLoop class methodsFor: 'as yet unclassified' stamp: 'rww 5/26/2021 14:42'!
allCodingLoops

	| codingLoops |
	codingLoops := OrderedCollection new.
	codingLoops add: (RSErasureByteOutputInputExpCodingLoop new).
	codingLoops add: (RSErasureByteInputOutputExpCodingLoop new).
	codingLoops add: (RSErasureInputOutputByteExpCodingLoop new).
	codingLoops add: (RSErasureOutputByteInputExpCodingLoop new).
	codingLoops add: (RSErasureOutputInputByteExpCodingLoop new).
	codingLoops add: (RSErasureInputByteOutputExpCodingLoop new).
	codingLoops add: (RSErasureInputOutputByteTableCodingLoop new).
	codingLoops add: (RSErasureByteInputOutputTableCodingLoop new).
	codingLoops add: (RSErasureInputByteOutputTableCodingLoop new).
	codingLoops add: (RSErasureOutputByteInputTableCodingLoop new).
	codingLoops add: (RSErasureOutputInputByteTableCodingLoop new).

	codingLoops add: (RSErasureByteOutputInputTableCodingLoop new).
	codingLoops := codingLoops asArray.
      ^ codingLoops! !

!RSErasureCodingLoop methodsFor: 'testing' stamp: 'rww 5/16/2021 09:09'!
checkSomeShardsGalois: galois matrixRows: matrixRows inputs: inputs inputCount: iCount toCheck: toCheck checkCount: oCount offset: offset byteCount: bCount tempBuffer: buffer

	self subclassResponsibility.! !

!RSErasureCodingLoop methodsFor: 'action' stamp: 'rww 5/16/2021 09:09'!
codeSomeShardsGalois: galois matrixRows: matrixRows inputs: inputs inputCount: iCount outputs: outputs outputCount: oCount offset: offset byteCount: bCount

	self subclassResponsibility.! !

!RSErasureCodingLoop methodsFor: 'action' stamp: 'rww 5/16/2021 09:11'!
computeValueGalois: galois matrixRow: matrixRow inputs: inputs inputIndex: inputIndex byteIndex: byteIndex value: priorValue

	self subclassResponsibility! !

!RSErasureCodingLoop methodsFor: 'testing' stamp: 'rww 5/16/2021 09:08'!
debugValueGalois: galois matrixRows: matrixRows inputs: inputs inputCount: inputCount toCheck: toCheck checkCount: parityShardCount offset: firstByte byteCount: byteCount tempBuffer: tempBuffer exception: exception

	self subclassResponsibility.! !

!RSErasureCodingLoop methodsFor: 'testing' stamp: 'rww 5/16/2021 15:48'!
debugValueGalois: galois matrixRows: matrixRows inputs: inputs inputCount: inputCount toCheck: toCheck exception: exception

	self subclassResponsibility.! !

RSErasureCodingLoop subclass: #RSErasureCodingLoopBase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

!RSErasureCodingLoopBase methodsFor: 'testing' stamp: 'rww 5/16/2021 18:52'!
checkSomeShardsGalois: galois matrixRows: matrixRows inputs: inputs inputCount: inputCount toCheck: toCheck checkCount: checkCount offset: offset byteCount: byteCount tempBuffer: buffer

	toCheck with: matrixRows do: [:output :matrixRow | | value |
		offset
			to: (offset + byteCount - 1)
			do: [:byteIndex |
				value := 0.
				(0 to: (inputCount - 1))
					do: [:inputIndex |
						value := self 
							computeValueGalois: galois 
							matrixRow: matrixRow 
							inputs: inputs 
							inputIndex: inputIndex 
							byteIndex: byteIndex 
							value: value].
				((output at: (byteIndex + 1)) ~= value)
					ifTrue: [ ^ false]]].
	^ true
! !

!RSErasureCodingLoopBase methodsFor: 'testing' stamp: 'rww 5/16/2021 22:43'!
debugValueGalois: galois matrixRows: matrixRows inputs: inputs inputCount: inputCount toCheck: toCheck exception: exception

	| byteIndex matrixRow output value |
	value := 0.
	byteIndex := exception byteIndex + 1.
	output := toCheck at: (exception outputIndex + 1).
	matrixRow := matrixRows at: (exception outputIndex + 1).
	(0 to: (inputCount - 1))
		do: [:inputIndex |
			value := self 
				computeValueGalois: galois 
				matrixRow: matrixRow 
				inputs: inputs 
				inputIndex: inputIndex 
				byteIndex: byteIndex 
				value: value.
			((toCheck indexOf: output) == (exception outputIndex + 1) & (byteIndex == (exception byteIndex + 1)))
				ifTrue: [
					Transcript cr; show: 
						'inputIndex: ',  (galois normalizeIndex: inputIndex), 
						' outputIndex: ', (toCheck indexOf: output), 
						' byteIndex: ', (galois normalizeIndex: (byteIndex + 1)),
						' accumulated value: ', value]].
					Transcript cr; show: (' output value: ', (output at: (byteIndex + 1))).
					Transcript cr; show: (' calc value: ', value); cr.
	^ value! !

RSErasureCodingLoopBase subclass: #RSErasureExpCodingLoop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

RSErasureExpCodingLoop subclass: #RSErasureByteInputOutputExpCodingLoop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

!RSErasureByteInputOutputExpCodingLoop methodsFor: 'action' stamp: 'rww 5/16/2021 18:51'!
codeSomeShardsGalois: galois matrixRows: matrixRows inputs: inputs inputCount: inputCount outputs: outputs outputCount: outputCount offset: offset byteCount: byteCount

	offset
		to: (offset + byteCount - 1)
		do: [:byteIndex |
			0
				to: (inputCount - 1)
				do: [:inputIndex |
					| value |
					value := 0.
					outputs with: matrixRows do: [:output :matrixRow |
						value := output at: (byteIndex + 1).
						value := self 
							computeValueGalois: galois 
							matrixRow: matrixRow 
							inputs: inputs 
							inputIndex: inputIndex 
							byteIndex: byteIndex 
							value: value.
						output at: (byteIndex + 1) put: value]]].
! !

RSErasureExpCodingLoop subclass: #RSErasureByteOutputInputExpCodingLoop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

!RSErasureByteOutputInputExpCodingLoop methodsFor: 'action' stamp: 'rww 5/16/2021 18:52'!
codeSomeShardsGalois: galois matrixRows: matrixRows inputs: inputs inputCount: inputCount outputs: outputs outputCount: outputCount offset: offset byteCount: byteCount

	| value |
	offset
		to: (offset + byteCount - 1)
		do: [:byteIndex |
			outputs with: matrixRows do: [:output :matrixRow |
				value := 0.
				0
					to: (inputCount - 1)
					do: [:inputIndex |
						value := self 
							computeValueGalois: galois 
							matrixRow: matrixRow 
							inputs: inputs 
							inputIndex: inputIndex 
							byteIndex: byteIndex 
							value: value].
				output at: (byteIndex + 1) put: value]].! !

!RSErasureExpCodingLoop methodsFor: 'apply primitives' stamp: 'rww 5/29/2021 08:53'!
computeValueGalois: galois matrixRow: matrixRow inputs: inputs inputIndex: inputIndex byteIndex: byteIndex value: priorValue

	| firstValue input lookupValue secondValue value |
	value := priorValue.
	input := inputs at: (inputIndex + 1).
	firstValue := matrixRow at: (inputIndex + 1).
	secondValue :=  input at: (byteIndex + 1).
	lookupValue := galois galoisMultiply: firstValue by: secondValue.
	value := galois 
		addOrSubtract: value
		by: lookupValue.
	^ value
! !

RSErasureExpCodingLoop subclass: #RSErasureInputByteOutputExpCodingLoop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

!RSErasureInputByteOutputExpCodingLoop methodsFor: 'action' stamp: 'rww 5/16/2021 18:55'!
codeSomeShardsGalois: galois matrixRows: matrixRows inputs: inputs inputCount: inputCount outputs: outputs outputCount: outoutCount offset: offset byteCount: byteCount
	
	0
		to: (inputCount - 1)
		do: [:inputIndex |
			| value |
			value := 0.
			offset
				to: (offset + byteCount - 1)
				do: [:byteIndex |
					outputs with: matrixRows do: [:output :matrixRow |
						value := output at: (byteIndex + 1).
						value := self 
							computeValueGalois: galois 
							matrixRow: matrixRow 
							inputs: inputs 
							inputIndex: inputIndex 
							byteIndex: byteIndex 
							value: value.
						output at: (byteIndex + 1) put: value]]].
! !

RSErasureExpCodingLoop subclass: #RSErasureInputOutputByteExpCodingLoop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

!RSErasureInputOutputByteExpCodingLoop methodsFor: 'action' stamp: 'rww 5/16/2021 18:55'!
codeSomeShardsGalois: galois matrixRows: matrixRows inputs: inputs inputCount: inputCount outputs: outputs outputCount: outputCount offset: offset byteCount: byteCount
	
	0
		to: (inputCount - 1)
		do: [:inputIndex |
			| value |
			value := 0.
			outputs with: matrixRows do: [:output :matrixRow |
				offset
					to: (offset + byteCount - 1)
					do: [:byteIndex |
						value := output at: (byteIndex + 1).
						value := self 
							computeValueGalois: galois 
							matrixRow: matrixRow 
							inputs: inputs 
							inputIndex: inputIndex 
							byteIndex: byteIndex 
							value: value.
						output at: (byteIndex + 1) put: value]]].
! !

RSErasureExpCodingLoop subclass: #RSErasureOutputByteInputExpCodingLoop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

!RSErasureOutputByteInputExpCodingLoop methodsFor: 'action' stamp: 'rww 5/16/2021 18:56'!
codeSomeShardsGalois: galois matrixRows: matrixRows inputs: inputs inputCount: inputCount outputs: outputs outputCount: outputCount offset: offset byteCount: byteCount

	outputs with: matrixRows do: [:output :matrixRow |
		offset
			to: (offset + byteCount - 1)
			do: [:byteIndex | | value |
				value := 0.
				0
					to: (inputCount - 1)
					do: [:inputIndex |
						value := output at: (byteIndex + 1).
						value := self 
							computeValueGalois: galois 
							matrixRow: matrixRow 
							inputs: inputs 
							inputIndex: inputIndex 
							byteIndex: byteIndex 
							value: value.
						output at: (byteIndex + 1) put: value]]].

! !

RSErasureExpCodingLoop subclass: #RSErasureOutputInputByteExpCodingLoop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

!RSErasureOutputInputByteExpCodingLoop methodsFor: 'action' stamp: 'rww 5/16/2021 18:56'!
codeSomeShardsGalois: galois matrixRows: matrixRows inputs: inputs inputCount: inputCount outputs: outputs outputCount: outoutCount offset: offset byteCount: byteCount

	outputs with: matrixRows do: [:output :matrixRow |
		0
			to: (inputCount - 1)
			do: [:inputIndex |
				| value |
				value := 0.
				offset
					to: (offset + byteCount - 1)
					do: [:byteIndex |
						value := output at: (byteIndex + 1).
						value := self 
							computeValueGalois: galois 
							matrixRow: matrixRow 
							inputs: inputs 
							inputIndex: inputIndex 
							byteIndex: byteIndex 
							value: value.
						output at: (byteIndex + 1) put: value]]].

! !

RSErasureCodingLoopBase subclass: #RSErasureTableCodingLoop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

RSErasureTableCodingLoop subclass: #RSErasureByteInputOutputTableCodingLoop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

!RSErasureByteInputOutputTableCodingLoop methodsFor: 'action' stamp: 'rww 5/16/2021 18:52'!
codeSomeShardsGalois: galois matrixRows: matrixRows inputs: inputs inputCount: inputCount outputs: outputs outputCount: outputCount offset: offset byteCount: byteCount

	offset
		to: (offset + byteCount - 1)
		do: [:byteIndex |
			(0 to: (inputCount - 1))
				do: [:inputIndex | | value |
					value := 0.
					outputs with: matrixRows do: [:output :matrixRow |
						value := output at: (byteIndex + 1).
						value := self 
							computeValueGalois: galois 
							matrixRow: matrixRow 
							inputs: inputs 
							inputIndex: inputIndex 
							byteIndex: byteIndex 
							value: value.
						output at: (byteIndex + 1) put: value]]].
! !

RSErasureTableCodingLoop subclass: #RSErasureByteOutputInputTableCodingLoop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

!RSErasureByteOutputInputTableCodingLoop methodsFor: 'action' stamp: 'rww 5/16/2021 18:52'!
codeSomeShardsGalois: galois matrixRows: matrixRows inputs: inputs inputCount: inputCount outputs: outputs outputCount: outputCount offset: offset byteCount: byteCount
	
	offset
		to: (offset + byteCount - 1)
		do: [:byteIndex |
			outputs with: matrixRows do: [:output :matrixRow | | value |
				value := 0.
				0
					to: (inputCount - 1)
					do: [:inputIndex |
						value := self 
							computeValueGalois: galois 
							matrixRow: matrixRow 
							inputs: inputs 
							inputIndex: inputIndex 
							byteIndex: byteIndex 
							value: value].
				output at: (byteIndex + 1) put: value]].
! !

RSErasureTableCodingLoop subclass: #RSErasureInputByteOutputTableCodingLoop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

!RSErasureInputByteOutputTableCodingLoop methodsFor: 'action' stamp: 'rww 5/16/2021 18:55'!
codeSomeShardsGalois: galois matrixRows: matrixRows inputs: inputs inputCount: inputCount outputs: outputs outputCount: outoutCount offset: offset byteCount: byteCount

	(0 to: (inputCount - 1))
		do: [:inputIndex | | value |
			value := 0.
			offset
				to: (offset + byteCount - 1)
				do: [:byteIndex |
					outputs with: matrixRows do: [:output :matrixRow |
						value := output at: (byteIndex + 1).
						value := self 
							computeValueGalois: galois 
							matrixRow: matrixRow 
							inputs: inputs 
							inputIndex: inputIndex 
							byteIndex: byteIndex 
							value: value.
						output at: (byteIndex + 1) put: value]]].
! !

RSErasureTableCodingLoop subclass: #RSErasureInputOutputByteTableCodingLoop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

!RSErasureInputOutputByteTableCodingLoop methodsFor: 'testing' stamp: 'rww 5/17/2021 01:48'!
checkSomeShardsGalois: galois matrixRows: matrixRows inputs: inputs inputCount: inputCount toCheck: toCheck checkCount: checkCount offset: offset byteCount: byteCount tempBuffer: tempBuffer

	| |
	(tempBuffer == nil)
		ifTrue: [^ super 
			checkSomeShardsGalois: galois
			matrixRows: matrixRows 
			inputs: inputs 
			inputCount: inputCount 
			toCheck: toCheck 
			checkCount: checkCount 
			offset: offset 
			byteCount: byteCount 
			tempBuffer: nil].

	toCheck with: matrixRows do: [:output :matrixRow | | value |
		(offset to: (offset + byteCount - 1))
			do: [:byteIndex |
				value := 0.
				(0 to: (inputCount - 1))
					do: [:inputIndex |
						value := self 
							computeValueGalois: galois 
							matrixRow: matrixRow 
							inputs: inputs 
							inputIndex: inputIndex 
							byteIndex: byteIndex 
							value: value.
						tempBuffer at: (byteIndex + 1) put: value].
				((output at: (byteIndex + 1)) ~= (tempBuffer at: (byteIndex + 1)))
					ifTrue: [^ false]]].
	^ true
! !

!RSErasureInputOutputByteTableCodingLoop methodsFor: 'action' stamp: 'rww 5/16/2021 18:56'!
codeSomeShardsGalois: galois matrixRows: matrixRows inputs: inputs inputCount: inputCount outputs: outputs outputCount: outputCount offset: offset byteCount: byteCount

	(0 to: (inputCount - 1))
		do: [:inputIndex | | value |
			value := 0.
			outputs with: matrixRows do: [:output :matrixRow |
				offset
					to: (offset + byteCount - 1)
					do: [:byteIndex |
						value := output at: (byteIndex + 1).
						value := self 
							computeValueGalois: galois 
							matrixRow: matrixRow 
							inputs: inputs 
							inputIndex: inputIndex 
							byteIndex: byteIndex 
							value: value.
						output at: (byteIndex + 1) put: value]]].
! !

RSErasureTableCodingLoop subclass: #RSErasureOutputByteInputTableCodingLoop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

!RSErasureOutputByteInputTableCodingLoop methodsFor: 'action' stamp: 'rww 5/16/2021 18:56'!
codeSomeShardsGalois: galois matrixRows: matrixRows inputs: inputs inputCount: inputCount outputs: outputs outputCount: outputCount offset: offset byteCount: byteCount
	
	| value |
	outputs with: matrixRows do: [:output :matrixRow |
		offset
			to: (offset + byteCount - 1)
			do: [:byteIndex |
				(0 to: (inputCount - 1))
					do: [:inputIndex | 
						value := output at: (byteIndex + 1).
						value := self 
							computeValueGalois: galois 
							matrixRow: matrixRow 
							inputs: inputs 
							inputIndex: inputIndex 
							byteIndex: byteIndex 
							value: value.
				output at: (byteIndex + 1) put: value]]].
! !

RSErasureTableCodingLoop subclass: #RSErasureOutputInputByteTableCodingLoop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

!RSErasureOutputInputByteTableCodingLoop methodsFor: 'testing' stamp: 'rww 5/16/2021 21:02'!
checkSomeShardsGalois: galois matrixRows: matrixRows inputs: inputs inputCount: inputCount toCheck: toCheck checkCount: checkCount offset: offset byteCount: byteCount tempBuffer: tempBuffer

	(tempBuffer == nil)
		ifTrue: [^ super 
			checkSomeShardsGalois: galois
			matrixRows: matrixRows 
			inputs: inputs 
			inputCount: inputCount 
			toCheck: toCheck 
			checkCount: checkCount 
			offset: offset 
			byteCount: byteCount 
			tempBuffer: nil].

	toCheck with: matrixRows do: [:output :matrixRow | | value |
		(offset to: (offset + byteCount - 1))
			do: [:byteIndex |
				value := 0.
				(0 to: (inputCount - 1))
					do: [:inputIndex |
						value := self 
							computeValueGalois: galois 
							matrixRow: matrixRow 
							inputs: inputs 
							inputIndex: inputIndex 
							byteIndex: byteIndex 
							value: value.
						tempBuffer at: (byteIndex + 1) put: value].
				((output at: (byteIndex + 1)) ~= (tempBuffer at: (byteIndex + 1)))
					ifTrue: [^ false]]].
	^ true

! !

!RSErasureOutputInputByteTableCodingLoop methodsFor: 'action' stamp: 'rww 5/16/2021 18:56'!
codeSomeShardsGalois: galois matrixRows: matrixRows inputs: inputs inputCount: inputCount outputs: outputs outputCount: outputCount offset: offset byteCount: byteCount

	outputs with: matrixRows do: [:output :matrixRow |
		(0 to: (inputCount - 1))
			do: [:inputIndex | | value |
				value := 0.
				offset
					to: (offset + byteCount - 1)
					do: [:byteIndex |
						value := output at: (byteIndex + 1).
						value := self 
							computeValueGalois: galois 
							matrixRow: matrixRow 
							inputs: inputs 
							inputIndex: inputIndex 
							byteIndex: byteIndex 
							value: value.
						output at: (byteIndex + 1) put: value]]].
! !

!RSErasureTableCodingLoop methodsFor: 'apply primitives' stamp: 'rww 5/29/2021 08:55'!
computeValueGalois: galois matrixRow: matrixRow inputs: inputs inputIndex: inputIndex byteIndex: byteIndex value: priorValue

	| firstValue input lookupValue secondValue value |
	value := priorValue.
	input := inputs at: (inputIndex + 1).
	firstValue := matrixRow at: (inputIndex + 1).
	secondValue :=  input at: (byteIndex + 1).
	lookupValue := galois tableMultiply: firstValue by: secondValue.
	value := galois 
		addOrSubtract: value
		by: lookupValue.
	^ value
	
! !

Object subclass: #RSErasureGalois
	instanceVariableNames: 'expTable logTable multiplicationTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

!RSErasureGalois class methodsFor: 'instance creation' stamp: 'rww 5/16/2021 09:30'!
newGalois

	RSErasureGaloisWithPlugin isPluginAvailable ifTrue: [ ^RSErasureGaloisWithPlugin new ].
	^RSErasureGalois new! !

!RSErasureGalois methodsFor: 'arithmetic' stamp: 'rww 5/28/2021 17:58'!
addOrSubtract: a by: b

	| aValue bValue |
	aValue := self maskValue: a.
	bValue := self maskValue: b.
	^ aValue bitXor: bValue.
! !

!RSErasureGalois methodsFor: 'arithmetic' stamp: 'rww 5/28/2021 09:43'!
divide: a by: b

	| logA logB logResult |
	(a == 0)
		ifTrue: [^ 0]
		ifFalse: [(b == 0)
			ifTrue: [^ Exception signal: 'Argument ''divisor'' is 0']].
	logA := self log: a.
	logB := self log: b.
	logResult := logA - logB.
	[logResult <= 0]
		whileTrue: [logResult := logResult + 255].
	(logResult == 0)
		ifTrue: [^ 1].
	^ self exp: logResult.
! !

!RSErasureGalois methodsFor: 'arithmetic' stamp: 'rww 5/26/2021 18:32'!
exp: a

	^expTable at: (self normalizeIndex: a).! !

!RSErasureGalois methodsFor: 'arithmetic' stamp: 'rww 5/28/2021 09:44'!
exp: base power: power

	| logA logResult |
	(power == 0)
		ifTrue: [^ 1].
	(base == 0)
		ifTrue: [^ 0].
	logA := self log: base.
	logResult := logA * power.
	[256 <= logResult]
		whileTrue: [logResult := logResult - 255].
	^ self exp: logResult.
! !

!RSErasureGalois methodsFor: 'accessing' stamp: 'rww 5/16/2021 07:57'!
expTable

	^ expTable! !

!RSErasureGalois methodsFor: 'galois arithmetic' stamp: 'rww 5/28/2021 09:45'!
galoisMultiply: a by: b

	| logA logB |
	(a == 0)
		ifTrue: [^ 0].
	(b == 0)
		ifTrue: [^ 0].
	logA := self log: a.
	logB := self log: b.
	^ self exp: (logA + logB).
! !

!RSErasureGalois methodsFor: 'initialize-release' stamp: 'rww 5/26/2021 15:38'!
generateMultiplicationTable

"        byte [] [] result = new byte [256] [256];
        for (int a = 0; a < FIELD_SIZE; a++) {
            for (int b = 0; b < FIELD_SIZE; b++) {
                result[a][b] = multiply((byte) a, (byte) b);
            }
        }
        return result;"

	| result |
	result := OrderedCollection new.
	0
		to: 255
		do: [:a |
			result add: (OrderedCollection new).
			0
				to: 255
				do: [:b |
					(result at: (a + 1)) add: (self galoisMultiply: a by: b)]].
	^ (result asArray collect: [:e | e asArray]) asArray.! !

!RSErasureGalois methodsFor: 'initialize-release' stamp: 'rww 5/29/2021 13:10'!
initialize

	self initializeLogTable.
	self initializeExpTable.
	multiplicationTable := self generateMultiplicationTable.

! !

!RSErasureGalois methodsFor: 'initialize-release' stamp: 'rww 5/16/2021 11:14'!
initializeExpTable
	"removed first value of 1 (0 index in Java)"

	expTable := #(1 2 4 8 16 32 64 128 29 58 116 232 205 135 19 38 76 152 45 90 180 117 234 201 143 3 6 12 24 48 96 192 157 39 78 156 37 74 148 53 106 212 181 119 238 193 159 35 70 140 5 10 20 40 80 160 93 186 105 210 185 111 222 161 95 190 97 194 153 47 94 188 101 202 137 15 30 60 120 240 253 231 211 187 107 214 177 127 254 225 223 163 91 182 113 226 217 175 67 134 17 34 68 136 13 26 52 104 208 189 103 206 129 31 62 124 248 237 199 147 59 118 236 197 151 51 102 204 133 23 46 92 184 109 218 169 79 158 33 66 132 21 42 84 168 77 154 41 82 164 85 170 73 146 57 114 228 213 183 115 230 209 191 99 198 145 63 126 252 229 215 179 123 246 241 255 227 219 171 75 150 49 98 196 149 55 110 220 165 87 174 65 130 25 50 100 200 141 7 14 28 56 112 224 221 167 83 166 81 162 89 178 121 242 249 239 195 155 43 86 172 69 138 9 18 36 72 144 61 122 244 245 247 243 251 235 203 139 11 22 44 88 176 125 250 233 207 131 27 54 108 216 173 71 142 1 2 4 8 16 32 64 128 29 58 116 232 205 135 19 38 76 152 45 90 180 117 234 201 143 3 6 12 24 48 96 192 157 39 78 156 37 74 148 53 106 212 181 119 238 193 159 35 70 140 5 10 20 40 80 160 93 186 105 210 185 111 222 161 95 190 97 194 153 47 94 188 101 202 137 15 30 60 120 240 253 231 211 187 107 214 177 127 254 225 223 163 91 182 113 226 217 175 67 134 17 34 68 136 13 26 52 104 208 189 103 206 129 31 62 124 248 237 199 147 59 118 236 197 151 51 102 204 133 23 46 92 184 109 218 169 79 158 33 66 132 21 42 84 168 77 154 41 82 164 85 170 73 146 57 114 228 213 183 115 230 209 191 99 198 145 63 126 252 229 215 179 123 246 241 255 227 219 171 75 150 49 98 196 149 55 110 220 165 87 174 65 130 25 50 100 200 141 7 14 28 56 112 224 221 167 83 166 81 162 89 178 121 242 249 239 195 155 43 86 172 69 138 9 18 36 72 144 61 122 244 245 247 243 251 235 203 139 11 22 44 88 176 125 250 233 207 131 27 54 108 216 173 71 142)! !

!RSErasureGalois methodsFor: 'initialize-release' stamp: 'rww 5/17/2021 16:23'!
initializeLogTable

	logTable := #(
            255 0    1   25    2   50   26  198
            3  223   51  238   27  104  199   75
            4  100  224   14   52  141  239  129
            28  193  105  248  200    8   76  113
            5  138  101   47  225   36   15   33
            53  147  142  218  240   18  130   69
            29  181  194  125  106   39  249  185
            201  154    9  120   77  228  114  166
            6  191  139   98  102  221   48  253
            226  152   37  179   16  145   34  136
            54  208  148  206  143  150  219  189
            241  210   19   92  131   56   70   64
            30   66  182  163  195   72  126  110
            107   58   40   84  250  133  186   61
            202   94  155  159   10   21  121   43
            78  212  229  172  115  243  167   87
            7  112  192  247  140  128   99   13
            103   74  222  237   49  197  254   24
            227  165  153  119   38  184  180  124
            17   68  146  217   35   32  137   46
            55   63  209   91  149  188  207  205
            144  135  151  178  220  252  190   97
            242   86  211  171   20   42   93  158
            132   60   57   83   71  109   65  162
            31   45   67  216  183  123  164  118
            196   23   73  236  127   12  111  246
            108  161   59   82   41  157   85  170
            251   96  134  177  187  204   62   90
            203   89   95  176  156  169  160   81
            11  245   22  235  122  117   44  215
            79  174  213  233  230  231  173  232
            116  214  244  234  168   80   88  175).
! !

!RSErasureGalois methodsFor: 'arithmetic' stamp: 'rww 5/26/2021 18:07'!
log: a

	(a = 0)
		ifTrue: [RSErasureIllegalArgumentError signal: 'zero argument'].
	^ logTable at: (self normalizeIndex: (self maskValue: a)).! !

!RSErasureGalois methodsFor: 'accessing' stamp: 'rww 5/16/2021 08:59'!
logTable

	^ logTable! !

!RSErasureGalois methodsFor: 'normalizing' stamp: 'rww 5/29/2021 12:53'!
maskValue: value

	^ ((value < 0)
 			ifTrue: [value twosComplement]
			ifFalse: [value]) bitAnd: 16rFF.
! !

!RSErasureGalois methodsFor: 'accessing' stamp: 'rww 5/16/2021 07:57'!
multiplicationTable

	^ multiplicationTable! !

!RSErasureGalois methodsFor: 'normalizing' stamp: 'rww 5/26/2021 18:36'!
normalizeIndex: index

	^ index + 1.! !

!RSErasureGalois methodsFor: 'table arithmetic' stamp: 'rww 5/26/2021 18:39'!
tableMultiply: a by: b

	(a = 0)
		ifTrue: [^ 0]
		ifFalse: [(b = 0)
				ifTrue: [^0]].
	^ (self multiplicationTable  at: (self normalizeIndex: (self maskValue: a))) at: (self normalizeIndex: (self maskValue: b)).
! !

Object subclass: #RSErasureGaloisWithPlugin
	instanceVariableNames: 'multiplicationTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

!RSErasureGaloisWithPlugin class methodsFor: 'testing' stamp: 'rww 5/29/2021 14:17'!
isPluginAvailable
	"Answer true if this platform has primitive support for the RSErasure Glaois."

	<primitive: 'primitiveIsPluginAvailable' module: 'RSErasurePlugin'>
	^ false! !

!RSErasureGaloisWithPlugin methodsFor: 'arithmetic' stamp: 'rww 5/29/2021 12:54'!
addOrSubtract: a by: b

	| aValue bValue |
	aValue := self maskValue: a.
	bValue := self maskValue: b.
	^ self primAddOrSubtract: aValue by: bValue.
! !

!RSErasureGaloisWithPlugin methodsFor: 'arithmetic' stamp: 'rww 5/29/2021 12:54'!
divide: a by: b

	| aValue bValue |
	aValue := self maskValue: a.
	bValue := self maskValue: b.
	^ self primDivide: aValue by: bValue.! !

!RSErasureGaloisWithPlugin methodsFor: 'arithmetic' stamp: 'rww 5/29/2021 12:55'!
exp: a

	| aValue |
	aValue := self maskValue: a.
	^ self primExp: aValue.! !

!RSErasureGaloisWithPlugin methodsFor: 'arithmetic' stamp: 'rww 5/29/2021 12:55'!
exp: a power: n

	| aValue nValue |
	aValue := self maskValue: a.
	nValue := self maskValue: n.
	^ self primExp: aValue power: nValue.! !

!RSErasureGaloisWithPlugin methodsFor: 'initialize-release' stamp: 'rww 5/29/2021 13:10'!
generateMultiplicationTable

"        byte [] [] result = new byte [256] [256];
        for (int a = 0; a < FIELD_SIZE; a++) {
            for (int b = 0; b < FIELD_SIZE; b++) {
                result[a][b] = multiply((byte) a, (byte) b);
            }
        }
        return result;"

	| result |
	result := OrderedCollection new.
	0
		to: 255
		do: [:a |
			result add: (OrderedCollection new).
			0
				to: 255
				do: [:b |
					(result at: (a + 1)) add: (self galoisMultiply: a by: b)]].
	^ (result asArray collect: [:e | e asArray]) asArray.! !

!RSErasureGaloisWithPlugin methodsFor: 'initialize-release' stamp: 'rww 5/29/2021 13:10'!
initialize

	multiplicationTable := self generateMultiplicationTable.
! !

!RSErasureGaloisWithPlugin methodsFor: 'arithmetic' stamp: 'rww 5/29/2021 12:55'!
log: a

	| aValue |
	aValue := self maskValue: a.
	^ self primLog: aValue.! !

!RSErasureGaloisWithPlugin methodsFor: 'helper' stamp: 'rww 5/29/2021 12:53'!
maskValue: value

	^ ((value < 0)
			ifTrue: [value twosComplement]
			ifFalse: [value]) bitAnd: 16rFF.
! !

!RSErasureGaloisWithPlugin methodsFor: 'accessing' stamp: 'rww 5/29/2021 13:11'!
multiplicationTable

	^ multiplicationTable! !

!RSErasureGaloisWithPlugin methodsFor: 'helper' stamp: 'rww 5/16/2021 07:38'!
normalizeIndex: index

	^  index bitAnd: 16rFF! !

!RSErasureGaloisWithPlugin methodsFor: 'primitives' stamp: 'rww 5/29/2021 12:51'!
primAddOrSubtract: arg1 by: arg2
	<primitive: 'primitiveAddOrSubtractBy' module: 'RSErasurePlugin'>
	^ self primitiveFailed! !

!RSErasureGaloisWithPlugin methodsFor: 'primitives' stamp: 'rww 5/16/2021 14:42'!
primDivide: arg1 by: arg2
	<primitive: 'primitiveDivideBy' module: 'RSErasurePlugin'>
	^ self primitiveFailed! !

!RSErasureGaloisWithPlugin methodsFor: 'primitives' stamp: 'rww 5/29/2021 08:59'!
primExp: arg1

	<primitive: 'primitiveExp' module: 'RSErasurePlugin'>
	^ self primitiveFailed! !

!RSErasureGaloisWithPlugin methodsFor: 'primitives' stamp: 'rww 5/16/2021 14:43'!
primExp: arg1 power: arg2
	<primitive: 'primitiveExpPower' module: 'RSErasurePlugin'>
	^ self primitiveFailed! !

!RSErasureGaloisWithPlugin methodsFor: 'primitives' stamp: 'rww 5/16/2021 14:42'!
primGaloisMultiply: arg1 by: arg2
	<primitive: 'primitiveGaloisMultiplyBy' module: 'RSErasurePlugin'>
	^ self primitiveFailed! !

!RSErasureGaloisWithPlugin methodsFor: 'primitives' stamp: 'rww 5/29/2021 08:59'!
primLog: arg1

	<primitive: 'primitiveLog' module: 'RSErasurePlugin'>
	^ self primitiveFailed! !

!RSErasureGaloisWithPlugin methodsFor: 'table arithmetic' stamp: 'rww 5/29/2021 13:11'!
tableMultiply: a by: b

	(a = 0)
		ifTrue: [^ 0]
		ifFalse: [(b = 0)
				ifTrue: [^0]].
	^ (self multiplicationTable  at: (self normalizeIndex: (self maskValue: a))) at: (self normalizeIndex: (self maskValue: b)).
! !

Object subclass: #RSErasureSampleDecoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!

Object subclass: #RSErasureSampleEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyRSErasure'!
